from datetime import datetime
from typing import Optional

from pydantic import BaseModel

from app.models.bet import BetStatus


class BetBase(BaseModel):
    amount: float
    odds: float
    potential_win: float


class BetCreate(BaseModel):
    outcome_id: int
    amount: float


class BetUpdate(BaseModel):
    status: BetStatus


class Bet(BetBase):
    id: int
    user_id: int
    outcome_id: int
    status: BetStatus
    settled_at: Optional[datetime] = None
    created_at: datetime

    class Config:
        from_attributes = True